/**
 * @class Describes Login page (scene)
 * @param options - options for page.
 */
function SceneLogin(options) {
	/**
	 * @field
	 * @description option of the page.
	 */
	this.options = options;
	
    var ime_txtLogin = null;
	var ime_txtPassword = null;
}

/**
 * @function
 * @description this function will be called only once when the scene manager show this scene first time
 * initialize the scene controls and styles, and initialize your variables here 
 * scene HTML and CSS will be loaded before this function is called
 */
SceneLogin.prototype.initialize = function () {
	Logger.write("SceneLogin.initialize()", "Login");
    this.isLoading = false;
    $('#limgLoggin').sfLoading();
    //SceneLogin.translate();
    ime_txtLogin = new IMEShell("txtLogin", callback_txtLogin, "en");
    ime_txtPassword = new IMEShell("txtPassword", callback_txtPassword);
    SceneLogin.isBtnLoginFocused = false;
};

/**
 * @function
 * @description Called when the IME object (txtLogin) has been fully created.
 * Sets position of the keypad, sets functions on events.
 * @param {object} cb - IME object.
 */
function callback_txtLogin(cb) {
	cb.setKeypadPos(650, 100, 9);
    //SceneLogin.focusLogin();
    cb.setKeyFunc(sf.key.RETURN, function(){
		try {
			SceneLogin.returnFocus();
			SceneLogin.focusLoginButton();
		} catch (error) {
			$("#lblError").sfLabel({text:ErrorHandler.HandleError(error,"Login")});
		}  
    });
	cb.setKeyFunc(sf.key.EXIT, function(){
		try {
			SceneLogin.returnFocus();
			SceneLogin.focusLoginButton();
			SceneLogin.handleExit();
		} catch (error) {
			$("#lblError").sfLabel({text:ErrorHandler.HandleError(error,"Login")});
		}  
    });
    cb.setKeyFunc(sf.key.ENTER, function(){
		try {
			//sf.scene.returnFocus();
			SceneLogin.returnFocus();
			SceneLogin.focusPassword();
		} catch (error) {
			$("#lblError").sfLabel({text:ErrorHandler.HandleError(error,"Login")});
		}  
    });
    cb.setKeyFunc(sf.key.DOWN, function(){
		try {
			//sf.scene.returnFocus();
			SceneLogin.returnFocus();
			SceneLogin.focusPassword();
		} catch (error) {
			$("#lblError").sfLabel({text:ErrorHandler.HandleError(error,"Login")});
		}  
    });
	cb.setKeyFunc(sf.key.UP, function(){
		try {
			SceneLogin.returnFocus();
			SceneLogin.focusLanguages();
		} catch (error) {
			$("#lblError").sfLabel({text:ErrorHandler.HandleError(error,"Login")});
		}  
    });
	cb.setKeyFunc(sf.key.BLUE, function(){
		try {
			SceneLogin.handleBlue();
		} catch (error) {
			$("#lblError").sfLabel({text:ErrorHandler.HandleError(error,"Login")});
		}  
    });
	
	cb.setKeypadChangeFunc('12key', moveLoginWindow12);
	cb.setKeypadChangeFunc('qwerty', moveLoginWindowQwerty);
}

/**
 * @function
 * @description Called when the IME object (txtPassword) has been fully created.
 * Sets position of the keypad, sets functions on events.
 * @param {object} cb - IME object.
 */
function callback_txtPassword(cb) {
    cb.setKeypadPos(650, 100, 9);
    cb.setKeyFunc(sf.key.RETURN, function(){
		try {
			SceneLogin.returnFocus();
			SceneLogin.focusLoginButton();
		} catch (error) {
			$("#lblError").sfLabel({text:ErrorHandler.HandleError(error,"Login")});
		}  
    });
	cb.setKeyFunc(sf.key.EXIT, function(){
		try {
			SceneLogin.returnFocus();
			SceneLogin.focusLoginButton();
			SceneLogin.handleExit();
		} catch (error) {
			$("#lblError").sfLabel({text:ErrorHandler.HandleError(error,"Login")});
		}  
    });
    cb.setKeyFunc(sf.key.ENTER, function(){
        try {
            SceneLogin.returnFocus();
            SceneLogin.focusLoginButton();
        } catch (error) {
            $("#lblError").sfLabel({text:ErrorHandler.HandleError(error,"Login")});
        }  
    });
    cb.setKeyFunc(sf.key.UP, function(){
		try {
			//sf.scene.returnFocus();
			SceneLogin.returnFocus();
			SceneLogin.focusLogin();
		} catch (error) {
			ErrorHandler.HandleError(error,"Login");
		}
    });
    cb.setKeyFunc(sf.key.DOWN, function(){
		try {
			SceneLogin.returnFocus();
			SceneLogin.focusLoginButton();
		} catch (error) {
			$("#lblError").sfLabel({text:ErrorHandler.HandleError(error,"Login")});
		}  
    });
	cb.setKeyFunc(sf.key.BLUE, function(){
		try {
			SceneLogin.returnFocus();
			SceneLogin.handleBlue();
			SceneLogin.focusPassword();
		} catch (error) {
			$("#lblError").sfLabel({text:ErrorHandler.HandleError(error,"Login")});
		}  
    });
	
	cb.setKeypadChangeFunc('12key', moveLoginWindow12);
	cb.setKeypadChangeFunc('qwerty', moveLoginWindowQwerty);
}

/**
 * @function
 * @description Provides moving login window when popup is not shown.
 */
function moveLoginWindow12() {
	$("#SceneLogin #popup").css("left", "217px");
}

/**
 * @function
 * @description Provides moving login window when popup is shown.
 */
function moveLoginWindowQwerty() {
	$("#SceneLogin #popup").css("left", "30px");
}

/**
 * @function
 * @description Provides displaying panel of the language choosing
 */
SceneLogin.showLanguages = function(){
	$("#lbLoginLanguages").css({'visibility': 'visible'});
	$("#lbLoginLanguages").css({'opacity': '1'});
    $("#lbLoginLanguages").show();
    $("#panelLanguage").hide();
    $("#lbLoginLanguages").sfList("focus");
    SceneLogin.showedLanguages = true;
};

/**
 * @function
 * @description Provides hiding panel of the language choosing
 */
SceneLogin.hideLanguages = function(){
	$("#lbLoginLanguages").sfList("blur");
	$("#lbLoginLanguages").css({'visibility': 'hidden'});
	$("#lbLoginLanguages").css({'opacity': '0'});
    $("#lbLoginLanguages").hide();    
    $("#panelLanguage").show();
    SceneLogin.showedLanguages = false;
    SceneLogin.setDisplayLanguage();
};

/**
 * @function
 * @description Sets selected language on the panel languages from user settings.
 */
SceneLogin.setDisplayLanguage = function(){
    $("#panelLanguage").html(AppContext.ClientSettings.Language.name);
};

/**
 * @function
 * @description Move focus to the language panel.
 */
SceneLogin.focusLanguages = function(){   
	moveLoginWindow12();
	
    SceneLogin.btnIndex = 0;
    SceneLogin.isBtnLoginFocused = true;
    $("#btnCreateAccount").sfButton("blur");
    $("#panelLanguage").removeClass("selected");
    $("#panelLanguage").addClass("focused");
};

/**
 * @function
 * @description Move focus from the language panel.
 */
SceneLogin.blurLanguages = function(){
    $("#panelLanguage").addClass("selected");
    $("#panelLanguage").removeClass("focused");
};

/**
 * @function
 * @description Provides loading languages from {@link AppContext.Languages}.
 * And also bind them to languages list. 
 */
SceneLogin.loadLanguages = function(){  
	Logger.write("Loading languages", "Login", true);
    var languageElements = [];
    var selectedIndex = 0;
    for (var i = 0; i < AppContext.Languages.length; i++) {
		languageElements[i] = AppContext.Languages[i].name;
		if (AppContext.Languages[i].name == AppContext.ClientSettings.Language.name)  {
			selectedIndex = i;
		}
    }
	
    var perPage = languageElements.length;
	Logger.write("Selected index: " + selectedIndex, "Login", true);
	Logger.write("Per page: " + perPage, "Login", true);
	$("#lbLoginLanguages").sfList({data: languageElements, itemsPerPage: perPage });
	$("#lbLoginLanguages").sfList("move", selectedIndex);
	$("#lbLoginLanguages").sfList("blur");
	SceneLogin.hideLanguages();
};

/**
 * @function
 * @description Sets help bar content.
 */
SceneLogin.setHelpBar = function () {
	var passwordType = $("#txtPassword").attr("type");
	var blue = passwordType === "password" ? Resources.getResources().ShowPassword : Resources.getResources().HidePassword;
	$('#hbKeyHelp').sfKeyHelp({
		'blue': blue,
		'Enter': Resources.getResources().Select, 
		'updown': Resources.getResources().MoveCursor
	});
};

/**
 * @function
 * @description Provides translations on the page (scene)
 */
SceneLogin.translate = function(){
	SceneLogin.setHelpBar();
    $('#lblLogin').sfLabel({text:Resources.getResources().Login, width:'80px'});
    $('#loginTitle').sfLabel({text:Resources.getResources().Login, width:'80px'});
    $('#lblPassword').sfLabel({text:Resources.getResources().Password, width:'80px'});
    $('#btnLogin').sfButton({text:Resources.getResources().Login/*, width:'140px'*/});
    $("#lblError").sfLabel({text:Resources.getResources().SceneLoginWrongLoginError});
    $('#btnCreateAccount').sfButton({text:Resources.getResources().Registration/*, width:'140px'*/});
	$("#titlePopUp h2").html(Resources.getResources().ApplicationName);
	SceneLogin.loadLanguages();
	SceneLogin.setDisplayLanguage();
	Helpers.setImeLanguage('en');
	if (_g_ime.keySet == "qwerty") {
		moveLoginWindowQwerty();
	} else {
		moveLoginWindow12();
	}
};

/**
 * @function
 * @description Sets current language
 */
SceneLogin.setCurrentLanguage = function() {    
    var lang = AppContext.Languages[$("#lbLoginLanguages").sfList('getIndex')];
    SceneLogin.setLangToContext(lang);
};

/**
 * @function
 * @description Sets language to {@link AppContext}
 * @param {string} language
 */
SceneLogin.setLangToContext = function(language) {
    if(language.name!="None")
    {
		AppContext.ClientSettings.Language = language;           
		Resources.getResources(AppContext.ClientSettings.Language.cultureInfo);
		SceneLogin.translate();
    }           
};

/**
 * @event
 * @description Occurs when user successfully logged in.
 */
SceneLogin.successLogin = function(){
    SceneLogin.endLoading();
    sf.scene.returnFocus();
    sf.scene.hide('Login');
    SceneMainMenu.show();           
};

/**
 * @function
 * @description Updates language settings
 * @param {function} callback - event that occurs when all are done.
 * @param {function} errCallback - event that occurs when error is handle.
 */
SceneLogin.updateLanguageSettings = function(callback, errCallback){
    var language = AppContext.ClientSettings.Language;
    try {
		JsonServices.client.SetSettings(AppContext.user.sid, language.id, null, null, null, callback, errCallback);
    } catch (error) {
		ErrorHandler.HandleError(error, "Login");
    }  
};

/**
 * @function
 * @description Gets clients settings from web service
 */
SceneLogin.getClientSettings=function(){

    SceneLogin.startLoading();
    
    var errCallback = function (error) {
		$("#lblError").sfLabel({text: error});  
    };
    
    var callbackSuccess = function () {
		SceneLogin.successLogin();   
    };
    
    var callback = function (result) {
        try {
			Login.getClientSettings(callbackSuccess, errCallback);
        } catch (error) {
			$("#lblError").empty();
			$("#lblError").append(ErrorHandler.HandleError(error, "Login"));  
        }
    };
    
    SceneLogin.updateLanguageSettings(callback, callback);
};

/**
 * @function
 * @description Clears values in inputs
 */
SceneLogin.clear = function() {
	document.getElementById('txtPassword').value = "";
	document.getElementById('txtLogin').value = "";
	if ($("#txtPassword").attr("type") === "text") {
		SceneLogin.handleBlue();
	}
};

/**
 * @function
 * @description Try to login with selected login and password
 * @param {string} DUID - device unique id
 * @param {string} login - user login
 * @param {string} passwd - user password
 */
SceneLogin.login = function (DUID, login, passwd) {  
    Logger.write("=========1===========Login: "+login+"  Password: "+passwd, "Login");
    var successCb = function(result) { 
		Logger.write("successCb", "Login", true);
        try
        {
			SceneLogin.endLoading();
			SceneLogin.getClientSettings();                    
        }
        catch(error)
        {
			SceneLogin.endLoading();
			ErrorHandler.HandleError(error,"Login");  
        }
    };
    
    var errCb = function(error)
    {
         SceneLogin.endLoading();
         $("#lblError").sfLabel({text:error});  
    };
	
    Login.login(DUID, login, passwd, successCb, errCb);
};

/**
 * @function
 * @description Shows "Loading" element and hides others
 */
SceneLogin.startLoading = function () {
    this.isLoading = true;
    $('#divLogin').css('visibility', 'hidden');
    $('#limgLoggin').sfLoading('show');
    //$('#hbKeyHelp').sfKeyHelp('hide');
};

/**
 * @function
 * @description Hides "Loading" element and shows others
 */
SceneLogin.endLoading = function () {
    this.isLoading = false;
    $('#divLogin').css('visibility', 'visible');
    $('#limgLoggin').sfLoading('hide');
    //$('#hbKeyHelp').sfKeyHelp('show');
};

/**
 * @function
 * @description Move focus to "Password" textbox
 */
SceneLogin.focusPassword = function () {
	Logger.write("SceneLogin.focusPassword()", "Login");
    /*$('#txtPassword').sfTextInput("focus");*/
	//$("#txtPassword").focus();
	document.getElementById("txtPassword").focus();
    SceneLogin.btnIndex = 2;
};

/**
 * @function
 * @description Move focus to "Login" textbox
 */
SceneLogin.focusLogin = function () {
	Logger.write("SceneLogin.focusLogin()", "Login");
      //$('#txtLogin').sfTextInput("focus");
	  //$("#txtLogin").focus();
	  document.getElementById("txtLogin").focus();
	  SceneLogin.btnIndex = 1;
};

/**
 * @function
 * @description Move focus to login button
 */
SceneLogin.focusLoginButton = function () {
	moveLoginWindow12();
	
	Logger.write("SceneLogin.focusLoginButton()", "Login");
	$("#btnLogin").sfButton("focus");
	SceneLogin.btnIndex = 3;
};

/**
 * @function
 * @description Provides returning focus on default (login)
 */
SceneLogin.returnFocus = function () {
	Helpers.returnFocus("Login");
};

/**
 * @event
 * @description This function will be called when the scene manager show this scene 
 */
SceneLogin.prototype.handleShow = function () {
	Logger.write("SceneLogin.handleShow()", "Login");
	Logger.write("Login button outer HTML1: " + $($("#btnLogin").parent().clone()).html(), "Login", true);
    SceneLogin.translate();
    SceneLogin.clear();
	
	if (!SceneMainMenu.showed)
    {
        if(AppContext.CurrentScene!="")
        {
			SceneLogin.sender=AppContext.CurrentScene;
        }
        AppContext.CurrentScene = "Login";     
        SceneLogin.focusLogin();   
        $("#btnLogin").sfButton("blur");
     }
     else
     {
         sf.scene.focus(AppContext.CurrentScene);
     }
};

/**
 * @event
 * @description This function will be called when the scene manager hide this scene 
 */
SceneLogin.prototype.handleHide = function () {
	Logger.write("SceneLogin.handleHide()", "Login");
};

/**
 * @event
 * @description This function will be called when the scene manager focus this scene
 */
SceneLogin.prototype.handleFocus = function () {
	Logger.write("SceneLogin.handleFocus()", "Login");
};

/**
 * @event
 * @description This function will be called when the scene manager move focus to another scene from this scene
 */
SceneLogin.prototype.handleBlur = function () {
	Logger.write("SceneLogin.handleBlur()", "Login");
};

/**
 * @event
 * @description Occurs when up button pressed 
 */
SceneLogin.handleUp = function(){
	Logger.write("SceneLogin.handleUp()", "Login");
    try
    {
		if (SceneLogin.showedLanguages)
		{
			$("#lbLoginLanguages").sfList("prev");
			return;
		}

		if (SceneLogin.btnIndex == 0) {
			SceneLogin.blurLanguages();
			SceneLogin.focusLoginButton();
		} else if (SceneLogin.btnIndex == 1) {
			$("#txtLogin").sfTextInput("blur");
			SceneLogin.focusLanguages();
		} else if (SceneLogin.btnIndex == 2) {
			$("#txtPassword").sfTextInput("blur");
			SceneLogin.focusLogin();
		} else if (SceneLogin.btnIndex == 3) {
			$("#btnLogin").sfButton("blur");
			SceneLogin.focusPassword();
		}
    }
    catch(error)
    {
		ErrorHandler.HandleError(error,"Login");  
    }
};

/**
 * @event
 * @description Occurs when down button pressed 
 */
SceneLogin.handleDown = function () {
	Logger.write("SceneLogin.handleDown()", "Login");
    try
    {
		if (SceneLogin.showedLanguages)
		{
			$("#lbLoginLanguages").sfList("next");
			return;
		}

		if (SceneLogin.btnIndex == 0) {
			SceneLogin.blurLanguages();
			SceneLogin.focusLogin();
		} else if (SceneLogin.btnIndex == 1) {
			$("#txtLogin").sfTextInput("blur");
			SceneLogin.focusPassword();
		} else if (SceneLogin.btnIndex == 2) {
			$("#txtPassword").sfTextInput("blur");
			SceneLogin.focusLoginButton();
		} else if (SceneLogin.btnIndex == 3) {
			$("#btnLogin").sfButton("blur");
			SceneLogin.focusLanguages();
		}
    }
    catch(error)
    {
          ErrorHandler.HandleError(error,"Login");  
    }
};

/**
 * @event
 * @description Occurs when enter button pressed 
 */
SceneLogin.handleEnter = function () {
    try {
        if (this.isLoading)
            return;
            
		if (SceneLogin.btnIndex == 3) {
			SceneLogin.startLoading();
			var DUID = Helpers.getDUID();
			SceneLogin.login(DUID, document.getElementById('txtLogin').value, document.getElementById('txtPassword').value);
		} else if (SceneLogin.btnIndex == 0) {
			if (!SceneLogin.showedLanguages) {
				SceneLogin.showLanguages();
			} else {
				SceneLogin.setCurrentLanguage();
				SceneLogin.hideLanguages();
			}
		}    
    } catch (error) {
		SceneLogin.endLoading();
		ErrorHandler.HandleError(error,"Login");  
    }
};

/**
 * @event
 * @description (Now not used) Occurs when blue (D) button pressed 
 */
SceneLogin.handleBlue = function () {
	
}

/**
 * @event
 * @description Occurs when return button pressed 
 */
SceneLogin.handleReturn = function () {
	var resultCallback = function (result) {
		if (result) {
			widgetAPI.sendReturnEvent();
		}
	};
	SceneDialogPopUp.showExitDialog("Login", resultCallback);
};

/**
 * @event
 * @description Occurs when exit button pressed 
 */
SceneLogin.handleExit = function () {
	var resultCallback = function (result) {
		if (result) {
			AppEvents.Exit();
		}
	};
	SceneDialogPopUp.showExitDialog("Login", resultCallback);
};

/**
 * @event
 * @description This function will be called when some key was pressed on the scene.
 */
SceneLogin.prototype.handleKeyDown = function (keyCode) {
	Logger.write("SceneLogin.handleKeyDown(" + keyCode + ")", "Login");
	// TODO : write an key event handler when this scene get focused
    if (!SceneLogin.isLoading) {
        switch (keyCode) {        
            case sf.key.LEFT:
                break;
            case sf.key.RIGHT:
                break;
            case sf.key.UP:
                SceneLogin.handleUp();
                break;
            case sf.key.DOWN:
                SceneLogin.handleDown();
                break;
            case sf.key.ENTER:
               SceneLogin.handleEnter();
                break;
			case sf.key.BLUE:
				SceneLogin.handleBlue();
				break;
            case sf.key.RETURN:
                widgetAPI.blockNavigation(event);
				SceneLogin.handleReturn();
                break;
            case sf.key.EXIT:
                try
                {
                    widgetAPI.blockNavigation(event);
					SceneLogin.handleExit();
                }
                catch(error)
                {
					ErrorHandler.HandleError(error,"Login");  
                }     
                break;
            default:         
                widgetAPI.blockNavigation(event);
                break;
        }
    }
};
