/**
 * @author EvgeniyV
 */
 
/**
 * @class Application events 
 */
AppEvents = {};
 
/**
 * @function
 * @description Occurs when AppEvents class is loading.
 */
AppEvents.onLoad = function() {
	Logger.write("[on load]", "AppEvents");
	window.onShow = onShowEventHandler;
    widgetAPI = new Common.API.Widget();
    widgetAPI.sendReadyEvent();
    pluginAPI = new Common.API.Plugin();    
    Network.init();
};

/**
 * @function
 * @description Occurs when AppEvents class is unloading.
 */
AppEvents.onUnLoad = function () {
	Logger.write("[on unload]", "AppEvents");
    tvKey = new Common.API.TVKeyValue();
    pluginAPI.unregistKey(tvKey.KEY_SOURCE);
    if  (ScenePlayer.isPlaying == true)
    {
        ScenePlayer.stop();
    }
};

/**
 * @function
 * @description Provides exitting from AppEvents class.
 */
AppEvents.Exit = function(){
    widgetAPI.blockNavigation(event);
    if  (ScenePlayer.isPlaying == true)
    {
        ScenePlayer.stop();
    }
    widgetAPI.sendExitEvent();
};

/**
 * @event
 * @description Occurs when event is handled.
 */
onShowEventHandler = function(){
    Logger.write("onShowEventHandler()", "AppEvents");
    
    var nnaviPlugin = document.getElementById('pluginObjectNNavi');
    nnaviPlugin.SetBannerState(2);
    tvKey = new Common.API.TVKeyValue();
    
	pluginAPI.registKey(tvKey.KEY_SOURCE);
    // For volume OSD
    Logger.write("Regist Vol Up: ", pluginAPI.registKey(tvKey.KEY_VOL_UP), "AppEvents", true);
    Logger.write("Regist Vol Down: ", pluginAPI.registKey(tvKey.KEY_VOL_DOWN), "AppEvents", true);
    pluginAPI.registKey(tvKey.KEY_MUTE);
    
    pluginAPI.unregistKey(tvKey.KEY_MENU);
    pluginAPI.unregistKey(tvKey.KEY_INFOLINK);
    pluginAPI.unregistKey(tvKey.KEY_CONTENT); 
};